"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Emoji = _interopRequireDefault(require("../Emoji"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const Navbar = ({
  data,
  handleSelectInNavbar,
  ...props
}) => {
  // roving tabindex
  const [index, setIndex] = (0, _react.useState)(0);

  const onNavbarKeyDown = event => {
    switch (event.key) {
      case 'Enter':
        return handleSelectInNavbar(Object.keys(data)[index]);

      case 'ArrowLeft':
        return index > 0 && setIndex(index => index - 1);

      case 'ArrowRight':
        return index < Object.keys(data).length - 1 && setIndex(index => index + 1);

      case 'Home':
        return index > 0 && setIndex(0);

      case 'End':
        return index < Object.keys(data).length - 1 && setIndex(Object.keys(data).length - 1);
    }
  };

  const onNavbarClick = (index, category) => event => {
    setIndex(index);
    handleSelectInNavbar(category);
  };

  return /*#__PURE__*/_react.default.createElement("div", _extends({
    className: "emoji-picker-navbar"
  }, props, {
    role: "tablist",
    "aria-label": "emoji categories"
  }), Object.entries(data).map(([category, list], i) => {
    const props = {
      className: "emoji-picker-navbar-category",
      key: `navbar-${category}`,
      onClick: onNavbarClick(i, category),
      onKeyDown: onNavbarKeyDown,
      role: "tab",
      "aria-label": category,
      "aria-selected": false,
      tabIndex: -1,
      ...(i == index && {
        "aria-selected": true,
        tabIndex: 0,
        ref: button => {
          var _document$activeEleme;

          return Boolean((_document$activeEleme = document.activeElement) === null || _document$activeEleme === void 0 ? void 0 : _document$activeEleme.closest(".emoji-picker-navbar")) && (button === null || button === void 0 ? void 0 : button.focus());
        }
      })
    };
    return /*#__PURE__*/_react.default.createElement("button", props, /*#__PURE__*/_react.default.createElement(_Emoji.default, {
      emoji: list[0]
    }));
  }));
};

const MemoizedNavbar = /*#__PURE__*/(0, _react.memo)(Navbar);
var _default = MemoizedNavbar;
exports.default = _default;